FreeBSD Administration - Support #675

Install Traccar Server on FreeBSD
Status: Closed Start date: 10/14/2015
Priority: Normal Due date:

Assignee: Daniel Curtis % Done: 100%
Category: Global Positioning Server Estimated time: 4.00 hours
Target version: FreeBSD 9 Spent time: 4.50 hours
Description

This is a guide for installing the Traccar GPS tracking server on FreeBSD 9.

Prepare the Environment

o Make sure the system is up to date:
pkg update && pkg upgrade

e |nstall a few dependencies:

pkg install openjdk-Jjre maven3 mysgl-connector-java git unzip

® Create the traccar user and group:

pw groupadd traccar

pw useradd traccar -c Traccar -m -d /home/traccar —-g traccar -s /bin/sh

e Create a traccar directory:

mkdir /usr/local/www/traccar

e Change the ownership of the traccar directory to traccar user:

chown traccar:traccar /usr/local/www/traccar

Install MySQL Server

¢ |nstall mysql55-server:

pkg install mysqgl55-{server,client}

e Start and enable mysql at boot:

echo 'mysgl_enable="YES"' >> /etc/rc.conf

service mysqgl start

e Secure the installation:
mysqgl_secure_installation

e | og into the mysql interface:

mysgl —-u root -p

o Then create the user traccaruser for the database

CREATE USER 'traccaruser'@'localhost' IDENTIFIED BY 'SuperSecretPassword';
o And create the database traccardb and make the traccaruser the owner:

CREATE DATABASE IF NOT EXISTS “traccardb’;

GRANT ALL PRIVILEGES ON "traccardb  .* TO 'traccaruser'@'localhost';

o Then quit out of the mysq| interface:

flush privileges;
exit

Install Traccar Server

e Switch to the traccar user:

su — traccar

Install from Package

e Download and unzip the latest package:

fetch https://github.com/tananaev/traccar/releases/download/v3.1l/traccar-linux-64-3.1.zip
unzip traccar-linux-64-3.1.zip

e Run the installer:

sh traccar.run --noexec --target /usr/local/www/traccar

e Exit from the traccar user:

exit

o Create the traccar init script:

vi /usr/local/etc/rc.d/traccar

o And add the following:

#!/bin/sh
# PROVIDE: traccar

# REQUIRE: DAEMON

# BEFORE:

# KEYWORD: shutdown

# Add the following lines to /etc/rc.conf to enable ‘traccar':
#

# traccar_enable="YES"

#

/etc/rc.subr

name="traccar"
rcvar=traccar_enable

# read configuration and set defaults

load_rc_config "$name"
S{traccar_enable="NO"}
S{traccar_root="/usr/local/www/traccar"}
S{traccar_java="java"}
S{traccar_user="traccar"}
${traccar_stdout="/dev/null"}
${traccar_stderr="/dev/null"}

traccar_chdir=${traccar_root}

command="$traccar_java"

command_args="-jar S$Straccar_root/tracker-server.jar S$Straccar_root/conf/traccar.xml"
pidfile="/var/run/$name.pid"

required_files="S$traccar_root/conf/traccar.xml"

start_cmd="/usr/sbin/daemon -p $pidfile -u S$traccar_user $command $command_args > S$traccar

_stdout 2> S$traccar_stderr"

run_rc_command "$1”

e Make the init scrip executable:

chmod +x /usr/local/etc/rc.d/traccar

e Fix the configuration paths using sed:

sed -1 ''" —-e 's/\/opt/\/usr\/local\/www/g' /usr/local/www/traccar/conf/traccar.xml

e Edit the traccar config:

vi /usr/local/www/traccar/conf/traccar.xml

o And modify the database configuration:

<entry key='database.driver'>com.mysqgl. jdbc.Driver</entry>

<entry key='database.url'>]jdbc:mysqgl://127.0.0.1:3306/traccardb?allowMultiQueries=true&amp
;autoReconnect=true&amp; useUnicode=yes&amp; characterEncoding=UTF-8&amp; sessionVariables=sqg
1_mode=ANSI_QUOTES</entry>

<entry key='database.user'>traccaruser</entry>

<entry key='database.password'>SuperSecretPassword</entry>
e Start and enable traccar server:

echo 'traccar_enable="YES"' >> /etc/rc.conf
service traccar start

e Open a web browser and go to http://traccar.example.com:8082
o Default username is admin and password is admin.

Install Nginx

¢ Install nginx:
pkg install nginx
e Start and enable nginx at boot:

echo 'nginx_enable="YES"' >> /etc/rc.conf
service nginx start

e Create a configuration directory to make managing individual server blocks easier
mkdir /usr/local/etc/nginx/conf.d
e Edit the main nginx config file:

vi /usr/local/etc/nginx/nginx.conf

o And strip down the config file and add the include statement at the end to make it easier to handle various server blocks:

#user nobody;
worker_processes 1;
error_log /var/log/nginx-error.log;

events {

worker_connections 1024;

http {
include mime.types;
default_type application/octet-stream;

sendfile on;
#tcp_nopush on;

#keepalive_timeout O0;
keepalive_timeout 65;

#gzip on;

# Load config files from the /etc/nginx/conf.d directory

include /usr/local/etc/nginx/conf.d/*.conf;

e Then create the traccar.example.com server block config:
http://traccar.example.com:8082

vi /usr/local/etc/nginx/conf.d/traccar.example.com.conf

o And add the following:

server {
listen 80;
server_name traccar.example.com;
access_log /var/log/traccar.example.com-access.log;
error_log /var/log/traccar.example.com-error.log;

location / {
proxy_pass http://127.0.0.1:8082;
proxy_redirect off;
proxy_buffering off;

proxy_set_header Host Shost;
proxy_set_header X-Real-IP Sremote_addr;
proxy_set_header X-Forwarded-For S$proxy_add_x_forwarded_for;
port_in_redirect off;
proxy_connect_timeout 900;
proxy_send_timeout 900;
proxy_read_timeout 900;
send_timeout 900;
}
}
Resources

e https://www.traccar.org/
https://github.com/tananaev/traccar
https://www.traccar.org/build/
https://www.traccar.org/freebsd/
https://www.traccar.org/mysal/

History

#1 - 10/14/2015 06:49 PM - Daniel Curtis
- Description updated
- Status changed from New to Resolved

- % Done changed from 0 to 100

#2 - 10/14/2015 10:15 PM - Daniel Curtis

- Description updated

#3 - 10/15/2015 04:22 PM - Daniel Curtis

- Description updated

#4 - 11/27/2015 03:54 PM - Daniel Curtis

- Status changed from Resolved to Closed
